org.rrd4j.core

## Class RrdFileBackendFactory

- java.lang.Object
- - org.rrd4j.core.RrdBackendFactory
  - - org.rrd4j.core.RrdFileBackendFactory

- All Implemented Interfaces:
    Closeable, AutoCloseable
  Direct Known Subclasses:
    RrdNioBackendFactory, RrdRandomAccessFileBackendFactory

      public abstract class RrdFileBackendFactory
      extends RrdBackendFactory

  An abstract backend factory which is used to store RRD data to ordinary files on the disk.

  Every backend factory storing RRD data as ordinary files should inherit from it, some check are done in the code for instanceof.

- - ### Field Summary

    - ### Fields inherited from class org.rrd4j.core.RrdBackendFactory

      `cachingAllowed, DEFAULTFACTORY, name, scheme, validateHeader`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RrdFileBackendFactory()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canStore(URI uri)`
    `protected boolean` | `exists(String path)` Determines if a storage with the given path already exists.
    `URI` | `getCanonicalUri(URI uri)` Ensure that an URI is returned in a non-ambiguous way.
    `String` | `getPath(URI uri)` Extract the local path from an URI.
    `URI` | `getUri(String path)` Transform an path in a valid URI for this backend.

    - ### Methods inherited from class org.rrd4j.core.RrdBackendFactory

      `addActiveFactories, buildGenericUri, checkClosing, close, exists, findFactory, getActiveFactories, getBackend, getBackend, getDefaultFactory, getName, getRootUri, getScheme, open, resolve, setActiveFactories, shouldValidateHeader, shouldValidateHeader`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RrdFileBackendFactory

          public RrdFileBackendFactory()

  - ### Method Detail

    - #### canStore

          public boolean canStore(URI uri)

      Overrides:
        `canStore` in class `RrdBackendFactory`

    - #### exists

          protected boolean exists(String path)

      Determines if a storage with the given path already exists.

      Method to determine if a file with the given path already exists.

      Specified by:
        `exists` in class `RrdBackendFactory`
      Parameters:
        `path` - Storage path
      Returns:
        a boolean.

    - #### getCanonicalUri

          public URI getCanonicalUri(URI uri)

      Description copied from class: `RrdBackendFactory`
      Ensure that an URI is returned in a non-ambiguous way.
      Overrides:
        `getCanonicalUri` in class `RrdBackendFactory`
      Parameters:
        `uri` - a valid URI for this backend.
      Returns:
        the canonized URI.

    - #### getPath

          public String getPath(URI uri)

      Description copied from class: `RrdBackendFactory`
      Extract the local path from an URI.
      Overrides:
        `getPath` in class `RrdBackendFactory`
      Parameters:
        `uri` - The URI to parse.
      Returns:
        the local path from the URI.

    - #### getUri

          public URI getUri(String path)

      Description copied from class: `RrdBackendFactory`
      Transform an path in a valid URI for this backend.
      Overrides:
        `getUri` in class `RrdBackendFactory`
      Parameters:
        `path` - a path local to the current backend.
      Returns:
        an URI that the current backend can handle.